import os,sys,arcgisscripting
import numpy as np
import math as math

gp = arcgisscripting.create(9.3)

er=.02043

d=0.02
theta=1

inraster=gp.GetParameterAsText(0)
gp.workspace = gp.Describe(inraster).Path
# Create a describe object from an input raster
desc = gp.describe(inraster)
# Get the extent property 
extent = desc.extent

xmin=extent.xmin
xmax=extent.xmax
ymin=extent.ymin
ymax=extent.ymax

spatialref = desc.SpatialReference
linearunit = spatialref.linearunitname

sizex=int(round((xmax-xmin)/1000))
sizey=int(round((ymax-ymin)/1000))

#density=25
density=float(gp.GetParameterAsText(1))

#numyears=100
numyears=int(gp.GetParameterAsText(2))
outraster=gp.GetParameterAsText(3)

rows = gp.searchcursor(gp.GetParameterAsText(4))
row = rows.next()

hphy=float(gp.GetParameterAsText(5))
std=float(gp.GetParameterAsText(6))
pkill=float(gp.GetParameterAsText(7))
lambdas=float(gp.GetParameterAsText(8))

numcom=0
while row:
    numcom=numcom+1
    row = rows.Next()
    
#numcom=3
comlocation=np.ones((numcom,2))#how do I find length, numcom???
population=np.ones((numcom,numyears))

rows = gp.searchcursor(gp.GetParameterAsText(4))
row = rows.next()

i=0
k=0

while row:
    comlocation[i,0]=int((row.y-ymin)/1000)#MAYBE DO -0.5 HERE TO CENTER IT?
    comlocation[i,1]=int((row.x-xmin)/1000)
    for j in range(0,numyears):
        k=j+1
        population[i,j]=int(row.GetValue("pop"+str(k)))
    i=i+1
    row = rows.Next()
    
pi=3.14


n=np.ones((numyears+1,sizey,sizex))*density
n2=np.ones((sizey,sizex))*density
killtemp=np.zeros((sizey,sizex))
growth=np.zeros((sizey,sizex))
lam=np.zeros((numyears,sizey,sizex))
effortfun=np.zeros((numcom,sizey,sizex))
totaleffort=np.zeros((numcom,numyears))
killnumber=np.zeros((numcom,numyears,(sizex)*(sizey)+2))

for yr in range(0,numyears-1):
	killtemp[:,:]=np.zeros((sizey,sizex))
	count=0
	for i in range(0,sizey-1):
		for j in range(0,sizex-1):
			count=count+1
			n2[i,j]=d*(n[yr,i+1,j]+n[yr,i-1,j])+(1-4*d)*n[yr,i,j]+d*(n[yr,i,j+1]+n[yr,i,j-1])
			for numb in range(0,numcom):
				effortfun[numb,i,j]=hphy*population[numb,yr]*math.exp(-1/(2*std**2)*((comlocation[numb,0]-i)**2+(comlocation[numb,1]-j)**2))/(2*pi*math.sqrt((comlocation[numb,0]-i)**2+(comlocation[numb,1]-j)**2)+1)                      
				totaleffort[numb,yr]=totaleffort[numb,yr]+effortfun[numb,i,j]
				killnumber[numb,yr,count]=effortfun[numb,i,j]*pkill*er*n[yr,i,j]
			lam[yr,i,j]=sum(effortfun[:,i,j])*pkill*er*n[yr,i,j]
	killtemp[:,:]=lam[yr,:,:]
	growth[:,:]=n[yr,:,:]*lambdas-lambdas*n[yr,:,:]*(n[yr,:,:]/density)**theta
	n[yr+1,:,:]=n2[:,:]-killtemp[:,:]+growth[:,:]
	for i in range(0,sizey):
		for j in range(0,sizex):
			if (n[yr+1,i,j]<0):
				n[yr+1,i,j]=0

ntemp=n[numyears-1,:,:]
#xmin=323
#ymin=444

asciitemp=gp.workspace + '\\asciitemp.asc'
fg=file(asciitemp, 'w')
header="ncols %i\n" % sizex
header+="nrows %i\n" % sizey
header+="xllcorner %i\n" % xmin
header+="yllcorner %i\n" % ymin
header+="cellsize 1000\n"
header+="nodata_value %i\n" % density

fg.write(header)
for i in range(sizey-1,-1,-1):
    s = ""
    for j in range(0,sizex):
        s += "%f\t" % ntemp[i,j]
    fg.write(s)

fg.close()

gp.ASCIIToRaster_conversion(asciitemp, outraster, "INTEGER")

	
