import os,sys,arcgisscripting
import numpy as np
import math as math

gp = arcgisscripting.create(9.3)

er=.02043

d=0.02
theta=1

inraster=gp.GetParameterAsText(0)
gp.workspace = gp.Describe(inraster).Path
# Create a describe object from an input raster
desc = gp.describe(inraster)
# Get the extent property 
extent = desc.extent

xmin=extent.xmin
xmax=extent.xmax
ymin=extent.ymin
ymax=extent.ymax

spatialref = desc.SpatialReference
linearunit = spatialref.linearunitname

sizex=int(round((xmax-xmin)/1000))
sizey=int(round((ymax-ymin)/1000))

#density=25
density=float(gp.GetParameterAsText(1))

#numyears=100
outraster=gp.GetParameterAsText(2)

rows = gp.searchcursor(gp.GetParameterAsText(3))
row = rows.next()

hphy=float(gp.GetParameterAsText(4))
std=float(gp.GetParameterAsText(5))
pkill=float(gp.GetParameterAsText(6))
lambdas=float(gp.GetParameterAsText(7))
theta=float(gp.GetParameterAsText(8))

numcom=0
while row:
    numcom=numcom+1
    row = rows.Next()
    
comlocation=np.ones((numcom,2))
population=np.ones((numcom,1))

rows = gp.searchcursor(gp.GetParameterAsText(3))
row = rows.next()

i=0

while row:
    comlocation[i,1]=int((row.y-ymin)/1000)#MAYBE DO -0.5 HERE TO CENTER IT?
    comlocation[i,0]=int((row.x-xmin)/1000)
    population[i,0]=int(row.GetValue("pop"))
    i=i+1
    row = rows.Next()
    
pi=3.14


n=np.ones((sizey,sizex))*density

	
for i in range(0,sizey-1):
    for j in range(0,sizex-1):
        n[i,j]=(max(0,density**theta*(1-er*d*hphy/lambdas*sum(population[0:numcom,0]*np.exp(-1/(2*std**2)*((comlocation[0:numcom,0]-j)**2+(comlocation[0:numcom,1]-i)**2))/(2*pi*np.sqrt((comlocation[0:numcom,0]-j)**2+(comlocation[0:numcom,1]-i)**2)+1)))))**(1/theta)

ntemp=n[:,:]
#xmin=323
#ymin=444

asciitemp=gp.workspace + '\\asciitemp.asc'
fg=file(asciitemp, 'w')
header="ncols %i\n" % sizex
header+="nrows %i\n" % sizey
header+="xllcorner %i\n" % xmin
header+="yllcorner %i\n" % ymin
header+="cellsize 1000\n"
header+="nodata_value %i\n" % density

fg.write(header)
for i in range(sizey-1,-1,-1):
    s = ""
    for j in range(0,sizex):
        s += "%f\t" % ntemp[i,j]
    fg.write(s)

fg.close()

gp.ASCIIToRaster_conversion(asciitemp, outraster, "INTEGER")
